VAR
        long          pin
        long          temperature
        long          rtco      ' xx | hour | min | sec - long word
        long          msec      ' milliseconds elapsed since we switched on
        long          secon
        long          secoff
        long          secs      ' seconds elapsed since we switched on
        
PUB Start_Temp : retval
  msec := 0
  secon := 1
  secoff := 1
  ' This is required or else it will sit and try and do a conversion on P0 thus waiting forever
  temperature := 1
  retval := cognew(@get_temp,@pin)
  retval := retval + cognew(@rtc,@rtco)

PUB Start_Conversion(tpin)
  pin := tpin
  temperature := 0
  
PUB Get_Temperature : val
  val := temperature

PUB Get_Time : val
  val := rtco

PUB Get_Msec : val
  val := msec
  
PUB Get_Secon : val
  val := secon

PUB Get_Secoff : val
  val := secoff

PUB Reset_timers
  secon := 0
  secoff := 0
  
PUB Get_Secs : val
  val := secs
DAT

get_temp      org
:gtloop
              mov       loop, par
              add       loop, #4
:waitere      rdlong    delay, loop             ' Wait till we are asked to do it
              test      delay, allones wz
        if_nz jmp       #:waitere
              rdlong    loop, par
              mov       pinmask, #1
              shl       pinmask, loop
              mov       outa, #0

              mov       intemp, #0
              call      #resetp
              mov       data, #$CC
              call      #writebyte
              mov       data, #$44
              call      #writebyte
              mov       cycles, #0
              ' Need to add a timeout here!!
              
:readloop     add       cycles, #1              ' Cycle until conversion done
              call      #readbit
              
              test      inpin, allones  wz
       if_Z   jmp       #:readloop
:nextbit                       
              call      #resetp
              mov       data, #$CC

              call      #writebyte

              mov       data, #$BE
              call      #writebyte

              mov       data, #0
              call      #readbyte
              and       data, #$FF

              mov       intemp, data
              call      #readbyte
              and       data, #$FF
              shl       data, #8
              add       intemp, data

              mov       data, cycles
              shl       data, #16
              or        intemp, data

              mov       loop, par
              add       loop, #4
              wrlong    intemp, loop
              jmp       #:gtloop
              
writebyte     mov       loop, #8
              mov       lc, #$01
wbyte0        test      data, lc wz
        if_NZ jmp       #write1 
              jmp       #write0
wbytenext     shl       lc, #1
              djnz      loop, #wbyte0
writebyte_ret ret

write1        or        dira, pinmask           ' Pull pin low
              mov       delay, cnt
              add       delay, d10uS
              waitcnt   delay, 0
              andn      dira, pinmask           ' Let pin float
              mov       delay, cnt
              add       delay, d60uS
              waitcnt   delay, 0
              jmp       #wbytenext
              
write0        or        dira, pinmask
              mov       delay, cnt
              add       delay, d10uS
              add       delay, d60uS
              waitcnt   delay, 0
              andn      dira, pinmask
              mov       delay, cnt
              add       delay, d1uS
              waitcnt   delay, 0
              jmp       #wbytenext


readbyte      mov       loop, #8
              mov       lc, #$01
              mov       data, #0
:rbyte0       call      #readbit
              test      inpin, allones   wz
              muxnz     data, lc
              shl       lc, #1
              djnz      loop, #:rbyte0
readbyte_ret  ret

                                      

readbit       or        dira, pinmask
              mov       delay, cnt
              add       delay, d1uS
              waitcnt   delay, 0
              andn      dira, pinmask
              mov       delay, cnt
              add       delay, d10uS
              waitcnt   delay, 0
              mov       inpin, ina
              and       inpin, pinmask
              mov       delay, cnt
              add       delay, d60uS            ' Minimum read cycle time is 60uS
              waitcnt   delay, 0

readbit_ret   ret                            

resetp        or        dira, pinmask           ' Pull pin low
              mov       delay, cnt               
              add       delay, d500uS
              waitcnt   delay, 0
              andn      dira, pinmask           ' Let pin float
              mov       delay, cnt
              add       delay, d60uS
              waitcnt   delay, 0
              ' Can sample for presence pulse here if we like
              ' but we don't bother. Get temp values of $FFFF if
              ' not present
              mov       delay, cnt
              add       delay, d500uS
              waitcnt   delay, 0
resetp_ret    ret

d1uS           long      80             
d10uS          long      800
d500uS         long      40000
d60uS          long      4800

allones       long      $FFFFFFFF
zero          long      0

pinmask       res       1
loop          res       1
lc            res       1
delay         res       1
inpin         res       1
data          res       1
intemp        res       1
cycles        res       1

' Real time clock code

rtc           org
              mov       tHour, #0
              mov       tMin, #0
              mov       tSec, #0
              mov       tmSec, #0
              mov       tbtn, #0
              mov       msecs, #0
              mov       timer, cnt
              add       timer, reload
:rtcloop      waitcnt   timer, reload
'              add       tbtn, #1
'              cmp       tbtn, #$FF wz
'        if_nz jmp       #:msec
'              mov       tbtn, #0
'              mov       btnin, ina
'              test      btnin, btnmask wz
'        if_z  jmp       #:msec
'              test      btnin, #$80 wz
'        if_z  jmp       #:btmin
'              add       tHour,#1
'              cmp       tHour,#24   wz
'        if_z  mov       tHour,#0
':btmin
'              test      btnin, #$40 wz
'        if_z  jmp       #:btnsec
'              add       tMin,#1
'              cmp       tMin,#60    wz
'        if_z  mov       tMin,#0
':btnsec
'              test      btnin, #$20 wz
'        if_nz mov       tSec, #0
'        
:msec         add       tmSec, #1
              add       msecs, #1
              cmp       tmSec, ws   wz
        if_z  mov       tmSec, #0
        if_nz jmp       #:rtcloop
              call      #calcsec
              add       tSec, #1
              cmp       tSec, #60   wz
        if_nz jmp       #:rtcnext
              mov       tSec, #0
              add       tMin, #1
              cmp       tMin, #60   wz
        if_nz jmp       #:rtcnext
              mov       tMin, #0
              add       tHour,#1
              cmp       tHour,#24   wz
        if_nz jmp       #:rtcnext
              mov       tHour,#0
        
:rtcnext
              mov       otmp, tHour
              shl       otmp, #8
              add       otmp, tMin
              shl       otmp, #8
              add       otmp, tSec
              wrlong    otmp, par
              mov       otmp, par
              add       otmp, #4
              wrlong    msecs, otmp
              jmp       #:rtcloop
              
calcsec       mov       tmp, #1
              shl       tmp, #18
              mov       t2, ina
              test      t2, tmp   wz
              mov       tmp, par
              add       tmp, #8                 ' secon
        IF_NZ add       tmp, #4                 ' secoff
              rdlong    t2, tmp
              add       t2, #1
              wrlong    t2, tmp

              mov       tmp, par
              add       tmp, #16
              rdlong    t2, tmp
              add       t2, #1
              wrlong    t2, tmp
calcsec_ret   ret

reload        long      80000
ws            long      1000
btnmask       long      %11100000
second        long      $40C4B400
msecs         res       1
btnin         res       1
timer         res       1
tHour         res       1
tMin          res       1                     
tSec          res       1
tmSec         res       1
otmp          res       1
tbtn          res       1
tmp           res       1
t2            res       1